module Biz
  class Holiday

    include Comparable

    def initialize(date, time_zone)
      @date      = date
      @time_zone = time_zone
    end

    def contains?(time)
      date == Time.new(time_zone).local(time).to_date
    end

    def to_time_segment
      TimeSegment.new(
        Time.new(time_zone).on_date(date, DayTime.midnight),
        Time.new(time_zone).on_date(date, DayTime.endnight)
      )
    end

    def <=>(other)
      return unless other.is_a?(self.class)

      [date, time_zone] <=> [other.date, other.time_zone]
    end

    protected

    attr_reader :date,
                :time_zone

    public

    def to_date
      date
    end

  end
end
